/*****************************************************************************
 *  Rohde&Schwarz Instrument Driver Specific Attribute callbacks
 *
 *  WARNING: Do not add to, delete from, or otherwise modify the contents
 *           of this source file. It is generated from DrBase repository.
 *
 *  Built on: 2024-04-03 11:14:32Z
 *****************************************************************************/

#include "hmdmm.h"

/*****************************************************************************
 *- Repeated Capabilities ---------------------------------------------------*
 *****************************************************************************/

ViInt32 hmdmm_RsCoreRepCapTableCount = 0;

RsCoreRepCap hmdmm_RsCoreRepCapTable[1] =
  { /*
    No repeated capabilities defined for this driver.
    */
    { NULL, NULL, NULL }
  };

/*****************************************************************************
 *- Range Tables ------------------------------------------------------------*
 *****************************************************************************/

static RsCoreRangeTableDiscreteEntry HmDmm_rngFunctionEntries[12] =
  {
    { HMDMM_VAL_DC_VOLTS, "VOLT" },
    { HMDMM_VAL_AC_VOLTS, "VOLT:AC" },
    { HMDMM_VAL_DC_CURRENT, "CURR" },
    { HMDMM_VAL_AC_CURRENT, "CURR:AC" },
    { HMDMM_VAL_2_WIRE_RES, "RES" },
    { HMDMM_VAL_4_WIRE_RES, "FRES" },
    { HMDMM_VAL_FREQUENCY, "FREQ" },
    { HMDMM_VAL_TEMPERATURE, "SENS" },
    { HMDMM_VAL_CAPACITANCE, "CAP" },
    { HMDMM_VAL_CONTINUITY, "CONT" },
    { HMDMM_VAL_DIODE, "DIOD" },
    { HMDMM_VAL_FREQ_CURRENT, "FREQ:CURR" }
  };
RsCoreRangeTableDiscrete HmDmm_rngFunction = { 12, HmDmm_rngFunctionEntries };

static RsCoreRangeTableDiscreteEntry HmDmm_rngBandwidthEntries[3] =
  {
    { HMDMM_VAL_DETECTOR_BW_SLOW, "10" },
    { HMDMM_VAL_DETECTOR_BW_MEDIUM, "50" },
    { HMDMM_VAL_DETECTOR_BW_FAST, "400" }
  };
RsCoreRangeTableDiscrete HmDmm_rngBandwidth = { 3, HmDmm_rngBandwidthEntries };

static RsCoreRangeTableDiscreteEntry HmDmm_rngAutoEntries[3] =
  {
    { HMDMM_VAL_AUTO_OFF, "OFF" },
    { HMDMM_VAL_AUTO_ON, "ON" },
    { HMDMM_VAL_AUTO_ONCE, "ONCE" }
  };
RsCoreRangeTableDiscrete HmDmm_rngAuto = { 3, HmDmm_rngAutoEntries };

static ViReal64 HmDmm_rngApertureTimeEntries[3] = { 0.01, 0.1, 1 };
RsCoreRangeTableCoerced HmDmm_rngApertureTime = { 3, HmDmm_rngApertureTimeEntries, "s" };

RsCoreRangeTableRanged HmDmm_rngTriggerCount = { 1, 50000, "" };

RsCoreRangeTableRanged HmDmm_rngSave = { 0, 4, "" };

static RsCoreRangeTableDiscreteEntry HmDmm_rngMathFunctionEntries[6] =
  {
    { HMDMM_VAL_MATH_NULL, "NULL" },
    { HMDMM_VAL_MATH_DB, "DB" },
    { HMDMM_VAL_MATH_DBM, "DBM" },
    { HMDMM_VAL_MATH_AVER, "AVER" },
    { HMDMM_VAL_MATH_LIM, "LIM" },
    { HMDMM_VAL_MATH_POWER, "POW" }
  };
RsCoreRangeTableDiscrete HmDmm_rngMathFunction = { 6, HmDmm_rngMathFunctionEntries };

RsCoreRangeTableRanged HmDmm_rngdBReference = { 1.0e-6, 1000, "dBm" };

static ViReal64 HmDmm_rngdBmReferenceEntries[17] = { 50, 75, 93, 110, 124, 125, 135, 150, 250, 300, 500, 600, 800, 900, 1000, 1200, 8000 };
RsCoreRangeTableCoerced HmDmm_rngdBmReference = { 17, HmDmm_rngdBmReferenceEntries, "Ohm" };

static RsCoreRangeTableDiscreteEntry HmDmm_rngTransducerTypeEntries[2] =
  {
    { HMDMM_VAL_PROBE_RTD, "RTD" },
    { HMDMM_VAL_PROBE_FRTD, "FRTD" }
  };
RsCoreRangeTableDiscrete HmDmm_rngTransducerType = { 2, HmDmm_rngTransducerTypeEntries };

static RsCoreRangeTableDiscreteEntry HmDmm_rngTemperatureSensorTypeEntries[3] =
  {
    { HMDMM_VAL_SENSOR_PT100, "PT100" },
    { HMDMM_VAL_SENSOR_PT500, "PT500" },
    { HMDMM_VAL_SENSOR_PT1000, "PT1000" }
  };
RsCoreRangeTableDiscrete HmDmm_rngTemperatureSensorType = { 3, HmDmm_rngTemperatureSensorTypeEntries };

RsCoreRangeTableRanged HmDmm_rngRegister = { 0, 65535, "" };

static ViReal64 HmDmm_rngDCVoltageRangeEntries[5] = { 0.4, 4, 40, 400, 1000 };
RsCoreRangeTableCoerced HmDmm_rngDCVoltageRange = { 5, HmDmm_rngDCVoltageRangeEntries, "V" };

static ViReal64 HmDmm_rngDCCurrentRangeEntries[4] = { 0.02, 0.2, 2, 10 };
RsCoreRangeTableCoerced HmDmm_rngDCCurrentRange = { 4, HmDmm_rngDCCurrentRangeEntries, "A" };

static ViReal64 HmDmm_rngACVoltageRangeEntries[5] = { 0.4, 4, 40, 400, 750 };
RsCoreRangeTableCoerced HmDmm_rngACVoltageRange = { 5, HmDmm_rngACVoltageRangeEntries, "V" };

static ViReal64 HmDmm_rngACCurrentRangeEntries[4] = { 0.02, 0.2, 2, 10 };
RsCoreRangeTableCoerced HmDmm_rngACCurrentRange = { 4, HmDmm_rngACCurrentRangeEntries, "A" };

static ViReal64 HmDmm_rngTwoWiresResistanceRangeEntries[7] = { 400, 4000, 40000, 400000, 4000000, 40000000, 250000000 };
RsCoreRangeTableCoerced HmDmm_rngTwoWiresResistanceRange = { 7, HmDmm_rngTwoWiresResistanceRangeEntries, "Ohm" };

static RsCoreRangeTableDiscreteEntry HmDmm_rngAutoImpedanceEntries[2] =
  {
    { HMDMM_VAL_AUTO_IMPEDANCE_LOW, "LOW" },
    { HMDMM_VAL_AUTO_IMPEDANCE_HIGH, "HIGH" }
  };
RsCoreRangeTableDiscrete HmDmm_rngAutoImpedance = { 2, HmDmm_rngAutoImpedanceEntries };

static RsCoreRangeTableDiscreteEntry HmDmm_rngOnOffEntries[2] =
  {
    { HMDMM_VAL_STATE_OFF, "0" },
    { HMDMM_VAL_STATE_ON, "1" }
  };
RsCoreRangeTableDiscrete HmDmm_rngOnOff = { 2, HmDmm_rngOnOffEntries };

static RsCoreRangeTableDiscreteEntry HmDmm_rngTemperatureUnitEntries[3] =
  {
    { HMDMM_VAL_TEMP_UNIT_C, "C" },
    { HMDMM_VAL_TEMP_UNIT_F, "F" },
    { HMDMM_VAL_TEMP_UNIT_K, "K" }
  };
RsCoreRangeTableDiscrete HmDmm_rngTemperatureUnit = { 3, HmDmm_rngTemperatureUnitEntries };

static RsCoreRangeTableDiscreteEntry HmDmm_rngTemperatureRTDTypeEntries[3] =
  {
    { HMDMM_VAL_TEMP_RTD_PT100, "PT100" },
    { HMDMM_VAL_TEMP_RTD_PT500, "PT500" },
    { HMDMM_VAL_TEMP_RTD_PT1000, "PT1000" }
  };
RsCoreRangeTableDiscrete HmDmm_rngTemperatureRTDType = { 3, HmDmm_rngTemperatureRTDTypeEntries };

static RsCoreRangeTableDiscreteEntry HmDmm_rngTemperatureProbeTypeEntries[2] =
  {
    { HMDMM_VAL_TEMP_TRANSDUCER_PROBE_RTD, "RTD" },
    { HMDMM_VAL_TEMP_TRANSDUCER_PROBE_FRTD, "FRTD" }
  };
RsCoreRangeTableDiscrete HmDmm_rngTemperatureProbeType = { 2, HmDmm_rngTemperatureProbeTypeEntries };

static RsCoreRangeTableDiscreteEntry HmDmm_rngTriggerModeEntries[3] =
  {
    { HMDMM_VAL_TRIGGER_MANUAL, "MAN" },
    { HMDMM_VAL_TRIGGER_SINGLE, "SING" },
    { HMDMM_VAL_TRIGGER_AUTO, "AUTO" }
  };
RsCoreRangeTableDiscrete HmDmm_rngTriggerMode = { 3, HmDmm_rngTriggerModeEntries };

static RsCoreRangeTableDiscreteEntry HmDmm_rngTriggerAutoModeEntries[3] =
  {
    { HMDMM_VAL_TRIGGER_AUTO_CONTINUE, "CONT" },
    { HMDMM_VAL_TRIGGER_AUTO_ABOVE_THRESHOLD, "ABOV" },
    { HMDMM_VAL_TRIGGER_AUTO_BELOW_THRESHOLD, "BEL" }
  };
RsCoreRangeTableDiscrete HmDmm_rngTriggerAutoMode = { 3, HmDmm_rngTriggerAutoModeEntries };

static RsCoreRangeTableDiscreteEntry HmDmm_rngHardcopyFormatEntries[2] =
  {
    { HMDMM_VAL_HARDCOPY_FORMAT_BMP, "BMP" },
    { HMDMM_VAL_HARDCOPY_FORMAT_PNG, "PNG" }
  };
RsCoreRangeTableDiscrete HmDmm_rngHardcopyFormat = { 2, HmDmm_rngHardcopyFormatEntries };

static ViReal64 HmDmm_rngCapacitanceRangeEntries[6] = { 5E-09, 5E-08, 5E-07, 5E-06, 5E-05, 0.0005 };
RsCoreRangeTableCoerced HmDmm_rngCapacitanceRange = { 6, HmDmm_rngCapacitanceRangeEntries, "" };

static ViReal64 HmDmm_rngFourWiresResistanceRangeEntries[5] = { 400, 4000, 40000, 400000, 4000000 };
RsCoreRangeTableCoerced HmDmm_rngFourWiresResistanceRange = { 5, HmDmm_rngFourWiresResistanceRangeEntries, "Ohm" };

static RsCoreRangeTableDiscreteEntry HmDmm_rngADCRateEntries[3] =
  {
    { HMDMM_VAL_ADC_RATE_SLOW, "SLOW" },
    { HMDMM_VAL_ADC_RATE_MEDIUM, "MED" },
    { HMDMM_VAL_ADC_RATE_FAST, "FAST" }
  };
RsCoreRangeTableDiscrete HmDmm_rngADCRate = { 3, HmDmm_rngADCRateEntries };

RsCoreRangeTableRanged HmDmm_rngContinuityThreshold = { 0, 1.0e6, "" };

RsCoreRangeTableRanged HmDmm_rngDiodeThreshold = { 0.0, 5.0, "V" };

static RsCoreRangeTableDiscreteEntry HmDmm_rngDataLoggingFileFormatEntries[2] =
  {
    { HMDMM_VAL_DATA_LOG_FORMAT_CSV, "CSV" },
    { HMDMM_VAL_DATA_LOG_FORMAT_TXT, "TXT" }
  };
RsCoreRangeTableDiscrete HmDmm_rngDataLoggingFileFormat = { 2, HmDmm_rngDataLoggingFileFormatEntries };

static RsCoreRangeTableDiscreteEntry HmDmm_rngDataLoggingModeEntries[3] =
  {
    { HMDMM_VAL_DATA_LOG_MODE_UNLIMITED, "UNL" },
    { HMDMM_VAL_DATA_LOG_MODE_COUNT, "COUN" },
    { HMDMM_VAL_DATA_LOG_MODE_TIME, "TIME" }
  };
RsCoreRangeTableDiscrete HmDmm_rngDataLoggingMode = { 3, HmDmm_rngDataLoggingModeEntries };

RsCoreRangeTableRanged HmDmm_rngDataLoggingMeasurementInterval = { 0, 3600, "s" };

static RsCoreRangeTableDiscreteEntry HmDmm_rngIntExtEntries[2] =
  {
    { HMDMM_VAL_INT, "INT" },
    { HMDMM_VAL_EXT, "EXT" }
  };
RsCoreRangeTableDiscrete HmDmm_rngIntExt = { 2, HmDmm_rngIntExtEntries };


/*****************************************************************************
 *- Attributes --------------------------------------------------------------*
 *****************************************************************************/

RsCoreAttribute  g_RS_ATTR_RANGE_CHECK =
  {
    RS_ATTR_RANGE_CHECK,
    "Range Check",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_TRUE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_QUERY_INSTRUMENT_STATUS =
  {
    RS_ATTR_QUERY_INSTRUMENT_STATUS,
    "Query Instrument Status",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_TRUE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SIMULATE =
  {
    RS_ATTR_SIMULATE,
    "Simulate",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_DESCRIPTION =
  {
    RS_ATTR_SPECIFIC_DRIVER_DESCRIPTION,
    "Driver Description",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_PREFIX =
  {
    RS_ATTR_SPECIFIC_DRIVER_PREFIX,
    "Driver Prefix",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_LOCATOR =
  {
    RS_ATTR_SPECIFIC_DRIVER_LOCATOR,
    "Driver Locator",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_VENDOR =
  {
    RS_ATTR_SPECIFIC_DRIVER_VENDOR,
    "Driver Vendor",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_REVISION =
  {
    RS_ATTR_SPECIFIC_DRIVER_REVISION,
    "Driver Revision",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MAJOR_VERSION =
  {
    RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MAJOR_VERSION,
    "Class Specification Major Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MINOR_VERSION =
  {
    RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MINOR_VERSION,
    "Class Specification Minor Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SUPPORTED_INSTRUMENT_MODELS =
  {
    RS_ATTR_SUPPORTED_INSTRUMENT_MODELS,
    "Supported Instrument Models",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_GROUP_CAPABILITIES =
  {
    RS_ATTR_GROUP_CAPABILITIES,
    "Class Group Capabilities",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_FUNCTION_CAPABILITIES =
  {
    RS_ATTR_FUNCTION_CAPABILITIES,
    "Function Capabilities",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_CHANNEL_COUNT =
  {
    RS_ATTR_CHANNEL_COUNT,
    "Channel Count",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_DRIVER_SETUP =
  {
    RS_ATTR_DRIVER_SETUP,
    "Driver Setup",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_INSTRUMENT_MANUFACTURER =
  {
    RS_ATTR_INSTRUMENT_MANUFACTURER,
    "Instrument Manufacturer",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    "Rohde&Schwarz",
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_INSTRUMENT_MODEL =
  {
    RS_ATTR_INSTRUMENT_MODEL,
    "Instrument Model",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_INSTRUMENT_FIRMWARE_REVISION =
  {
    RS_ATTR_INSTRUMENT_FIRMWARE_REVISION,
    "Instrument Firmware Revision",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_OPTIONS_LIST =
  {
    RS_ATTR_OPTIONS_LIST,
    "Options List",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_IO_RESOURCE_DESCRIPTOR =
  {
    RS_ATTR_IO_RESOURCE_DESCRIPTOR,
    "Resource Descriptor",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_LOGICAL_NAME =
  {
    RS_ATTR_LOGICAL_NAME,
    "Logical Name",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_PRIMARY_ERROR =
  {
    RS_ATTR_PRIMARY_ERROR,
    "Primary Error",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SECONDARY_ERROR =
  {
    RS_ATTR_SECONDARY_ERROR,
    "Secondary Error",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_ERROR_ELABORATION =
  {
    RS_ATTR_ERROR_ELABORATION,
    "Error Elaboration",
    RS_VAL_READ_WRITE,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_MAJOR_VERSION =
  {
    RS_ATTR_SPECIFIC_DRIVER_MAJOR_VERSION,
    "Driver Major Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_MINOR_VERSION =
  {
    RS_ATTR_SPECIFIC_DRIVER_MINOR_VERSION,
    "Driver Minor Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_MINOR_MINOR_VERSION =
  {
    RS_ATTR_SPECIFIC_DRIVER_MINOR_MINOR_VERSION,
    "Driver Minor Minor Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_CLASS_DRIVER_MAJOR_VERSION =
  {
    RS_ATTR_CLASS_DRIVER_MAJOR_VERSION,
    "Class Major Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_CLASS_DRIVER_MINOR_VERSION =
  {
    RS_ATTR_CLASS_DRIVER_MINOR_VERSION,
    "Class Minor Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_ENGINE_MAJOR_VERSION =
  {
    RS_ATTR_ENGINE_MAJOR_VERSION,
    "Engine Major Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_ENGINE_MINOR_VERSION =
  {
    RS_ATTR_ENGINE_MINOR_VERSION,
    "Engine Minor Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_ENGINE_REVISION =
  {
    RS_ATTR_ENGINE_REVISION,
    "Engine Revision",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    "0",
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_OPC_TIMEOUT =
  {
    RS_ATTR_OPC_TIMEOUT,
    "Operation Complete (OPC) Timeout",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_FUNCTION =
  {
    HMDMM_ATTR_FUNCTION,
    "Measurement Function",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &HmDmm_rngFunction, NULL, NULL,
    "SENS:FUNC",
    // Defaults I32, I64, Float, Bool, String
    HMDMM_VAL_DC_VOLTS,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    hmdmm_doubleQuotedInt_ReadCallback,
    hmdmm_doubleQuotedInt_WriteCallback,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_ACTUAL_INSTRUMENT_CONFIGURATION =
  {
    HMDMM_ATTR_ACTUAL_INSTRUMENT_CONFIGURATION,
    "Actual Instrument Configuration",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    "CONF?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_DC_VOLTAGE_RANGE =
  {
    HMDMM_ATTR_DC_VOLTAGE_RANGE,
    "DC Voltage Range",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, &HmDmm_rngDCVoltageRange,
    "SENS:VOLT:RANGE",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    40.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_DC_VOLTAGE_AUTO_RANGE =
  {
    HMDMM_ATTR_DC_VOLTAGE_AUTO_RANGE,
    "DC Voltage Auto Range",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "VOLT:RANGE:AUTO",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_TRUE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_DC_VOLTAGE_AUTOZERO =
  {
    HMDMM_ATTR_DC_VOLTAGE_AUTOZERO,
    "DC Voltage Autozero",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &HmDmm_rngOnOff, NULL, NULL,
    "VOLT:ZERO:AUTO",
    // Defaults I32, I64, Float, Bool, String
    HMDMM_VAL_STATE_OFF,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_DC_VOLTAGE_NULL_FUNCTION_STATE =
  {
    HMDMM_ATTR_DC_VOLTAGE_NULL_FUNCTION_STATE,
    "DC Voltage Null Function State",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "VOLT:NULL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_DC_VOLTAGE_NULL =
  {
    HMDMM_ATTR_DC_VOLTAGE_NULL,
    "DC Voltage Null",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "VOLT:NULL:VAL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_DC_CURRENT_RANGE =
  {
    HMDMM_ATTR_DC_CURRENT_RANGE,
    "DC Current Range",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, &HmDmm_rngDCCurrentRange,
    "SENS:CURR:RANGE",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    10.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_DC_CURRENT_AUTO_RANGE =
  {
    HMDMM_ATTR_DC_CURRENT_AUTO_RANGE,
    "DC Current Auto Range",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "SENS:CURR:RANGE:AUTO",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_TRUE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_DC_CURRENT_NULL_FUNCTION_STATE =
  {
    HMDMM_ATTR_DC_CURRENT_NULL_FUNCTION_STATE,
    "DC Current Null Function State",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CURR:NULL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_DC_CURRENT_NULL =
  {
    HMDMM_ATTR_DC_CURRENT_NULL,
    "DC Current Null",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "CURR:NULL:VAL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_AC_VOLTAGE_DETECTOR_BANDWIDTH =
  {
    HMDMM_ATTR_AC_VOLTAGE_DETECTOR_BANDWIDTH,
    "AC Voltage Detector Bandwidth",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &HmDmm_rngBandwidth, NULL, NULL,
    "VOLT:AC:BAND",
    // Defaults I32, I64, Float, Bool, String
    HMDMM_VAL_DETECTOR_BW_MEDIUM,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    hmdmm_DoubleToInt_ReadCallback,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_AC_VOLTAGE_RANGE =
  {
    HMDMM_ATTR_AC_VOLTAGE_RANGE,
    "AC Voltage Range",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, &HmDmm_rngACVoltageRange,
    "SENS:VOLT:AC:RANGE",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    40.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_AC_VOLTAGE_AUTO_RANGE =
  {
    HMDMM_ATTR_AC_VOLTAGE_AUTO_RANGE,
    "AC Voltage Auto Range",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "SENS:VOLT:AC:RANGE:AUTO",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_TRUE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_AC_VOLTAGE_NULL_FUNCTION_STATE =
  {
    HMDMM_ATTR_AC_VOLTAGE_NULL_FUNCTION_STATE,
    "AC Voltage Null Function State",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "VOLT:AC:NULL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_AC_VOLTAGE_NULL =
  {
    HMDMM_ATTR_AC_VOLTAGE_NULL,
    "AC Voltage Null",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "VOLT:AC:NULL:VAL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_AC_CURRENT_DETECTOR_BANDWIDTH =
  {
    HMDMM_ATTR_AC_CURRENT_DETECTOR_BANDWIDTH,
    "AC Current Detector Bandwidth",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &HmDmm_rngBandwidth, NULL, NULL,
    "CURR:AC:BAND",
    // Defaults I32, I64, Float, Bool, String
    HMDMM_VAL_DETECTOR_BW_MEDIUM,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    hmdmm_DoubleToInt_ReadCallback,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_AC_CURRENT_RANGE =
  {
    HMDMM_ATTR_AC_CURRENT_RANGE,
    "AC Current Range",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, &HmDmm_rngACCurrentRange,
    "SENS:CURR:AC:RANGE",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    10.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_AC_CURRENT_AUTO_RANGE =
  {
    HMDMM_ATTR_AC_CURRENT_AUTO_RANGE,
    "AC Current Auto Range",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "SENS:CURR:AC:RANGE:AUTO",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_TRUE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_AC_CURRENT_NULL_FUNCTION_STATE =
  {
    HMDMM_ATTR_AC_CURRENT_NULL_FUNCTION_STATE,
    "AC Current Null Function State",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CURR:AC:NULL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_AC_CURRENT_NULL =
  {
    HMDMM_ATTR_AC_CURRENT_NULL,
    "AC Current Null",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "CURR:AC:NULL:VAL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_SELF_TEST =
  {
    HMDMM_ATTR_SELF_TEST,
    "Self Test",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    "*TST?",
    // Defaults I32, I64, Float, Bool, String
    1,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_SAVE =
  {
    HMDMM_ATTR_SAVE,
    "Save",
    RS_VAL_WRITE_ONLY,
    RS_VAL_INT32,
    NULL, &HmDmm_rngSave, NULL,
    "*SAV",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_RECALL =
  {
    HMDMM_ATTR_RECALL,
    "Recall",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, &HmDmm_rngSave, NULL,
    "*RCL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_DISPLAY_TEXT =
  {
    HMDMM_ATTR_DISPLAY_TEXT,
    "Display Text",
    RS_VAL_WRITE_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    "DISP:TEXT",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    "Hello World",
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_DISPLAY_CLEAR =
  {
    HMDMM_ATTR_DISPLAY_CLEAR,
    "Display Clear",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "DISP:TEXT:CLE",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_BEEPER_STATE =
  {
    HMDMM_ATTR_BEEPER_STATE,
    "Beeper State",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "SYST:BEEP:STAT",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_TRUE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_BEEP =
  {
    HMDMM_ATTR_BEEP,
    "Beep",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "SYST:BEEP",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_PRESET_REGISTER =
  {
    HMDMM_ATTR_PRESET_REGISTER,
    "Preset Register",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "STAT:PRES",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_STATUS_REGISTER_QUESTIONABLE_CONDITION =
  {
    HMDMM_ATTR_STATUS_REGISTER_QUESTIONABLE_CONDITION,
    "Status Register Questionable Condition",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, &HmDmm_rngRegister, NULL,
    "STAT:QUES:COND",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_STATUS_REGISTER_QUESTIONABLE_ENABLE =
  {
    HMDMM_ATTR_STATUS_REGISTER_QUESTIONABLE_ENABLE,
    "Status Register Questionable Enable",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, &HmDmm_rngRegister, NULL,
    "STAT:QUES:ENAB",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_STATUS_REGISTER_QUESTIONABLE_EVENT =
  {
    HMDMM_ATTR_STATUS_REGISTER_QUESTIONABLE_EVENT,
    "Status Register Questionable Event",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, &HmDmm_rngRegister, NULL,
    "STAT:QUES?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_STATUS_REGISTER_OPERATION_CONDITION =
  {
    HMDMM_ATTR_STATUS_REGISTER_OPERATION_CONDITION,
    "Status Register Operation Condition",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, &HmDmm_rngRegister, NULL,
    "STAT:OPER:COND",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_STATUS_REGISTER_OPERATION_ENABLE =
  {
    HMDMM_ATTR_STATUS_REGISTER_OPERATION_ENABLE,
    "Status Register Operation Enable",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, &HmDmm_rngRegister, NULL,
    "STAT:OPER:ENAB",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_STATUS_REGISTER_OPERATION_EVENT =
  {
    HMDMM_ATTR_STATUS_REGISTER_OPERATION_EVENT,
    "Status Register Operation Event",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, &HmDmm_rngRegister, NULL,
    "STAT:OPER?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_FREQ_APERTURE_TIME =
  {
    HMDMM_ATTR_FREQ_APERTURE_TIME,
    "Frequency Aperture Time",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, &HmDmm_rngApertureTime,
    "SENS:FREQ:APER",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    1.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_AUTO_FREQ_VOLTAGE_RANGE =
  {
    HMDMM_ATTR_AUTO_FREQ_VOLTAGE_RANGE,
    "Auto Frequency Voltage Range",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "SENS:FREQ:VOLT:RANGE:AUTO",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_FREQ_VOLTAGE_RANGE =
  {
    HMDMM_ATTR_FREQ_VOLTAGE_RANGE,
    "Frequency Voltage Range",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "SENS:FREQ:VOLT:RANGE",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    4.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_FREQ_CURRENT_AUTO_RANGE =
  {
    HMDMM_ATTR_FREQ_CURRENT_AUTO_RANGE,
    "Auto Frequency Current Range",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "SENS:FREQ:CURR:RANG:AUTO",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_TRUE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_FREQ_CURRENT_RANGE =
  {
    HMDMM_ATTR_FREQ_CURRENT_RANGE,
    "Frequency Current Range",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "SENS:FREQ:CURR:RANGE",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    20.0e-3,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_TWO_WIRES_RESISTANCE_RANGE =
  {
    HMDMM_ATTR_TWO_WIRES_RESISTANCE_RANGE,
    "Two Wires Resistance Range",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, &HmDmm_rngTwoWiresResistanceRange,
    "SENS:RES:RANG",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    4000.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_TWO_WIRES_RESISTANCE_AUTO_RANGE =
  {
    HMDMM_ATTR_TWO_WIRES_RESISTANCE_AUTO_RANGE,
    "Two Wires Resistance Auto Range",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "SENS:RES:RANGE:AUTO",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_TWO_WIRES_RESISTANCE_NULL_FUNCTION_STATE =
  {
    HMDMM_ATTR_TWO_WIRES_RESISTANCE_NULL_FUNCTION_STATE,
    "Two Wires Resistance Null Function State",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "RES:NULL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_TWO_WIRES_RESISTANCE_NULL =
  {
    HMDMM_ATTR_TWO_WIRES_RESISTANCE_NULL,
    "Two Wires Resistance Null",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "RES:NULL:VAL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_FOUR_WIRES_RESISTANCE_RANGE =
  {
    HMDMM_ATTR_FOUR_WIRES_RESISTANCE_RANGE,
    "Four Wires Resistance Range",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, &HmDmm_rngFourWiresResistanceRange,
    "SENS:FRES:RANG",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    4000.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_FOUR_WIRES_RESISTANCE_AUTO_RANGE =
  {
    HMDMM_ATTR_FOUR_WIRES_RESISTANCE_AUTO_RANGE,
    "Four Wires Resistance Auto Range",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "SENS:FRES:RANGE:AUTO",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_FOUR_WIRES_RESISTANCE_NULL_FUNCTION_STATE =
  {
    HMDMM_ATTR_FOUR_WIRES_RESISTANCE_NULL_FUNCTION_STATE,
    "Four Wires Resistance Null Function State",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "FRES:NULL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_FOUR_WIRES_RESISTANCE_NULL =
  {
    HMDMM_ATTR_FOUR_WIRES_RESISTANCE_NULL,
    "Four Wires Resistance Null",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "FRES:NULL:VAL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_TEMPERATURE_UNIT =
  {
    HMDMM_ATTR_TEMPERATURE_UNIT,
    "Temperature Unit",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &HmDmm_rngTemperatureUnit, NULL, NULL,
    "UNIT:TEMP",
    // Defaults I32, I64, Float, Bool, String
    HMDMM_VAL_TEMP_UNIT_C,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_TEMPERATURE_NULL_FUNCTION_STATE =
  {
    HMDMM_ATTR_TEMPERATURE_NULL_FUNCTION_STATE,
    "Temperature Null Function State",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "TEMP:NULL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_TEMPERATURE_NULL =
  {
    HMDMM_ATTR_TEMPERATURE_NULL,
    "Temperature Null",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "TEMP:NULL:VAL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_TEMPERATURE_RTD_TYPE =
  {
    HMDMM_ATTR_TEMPERATURE_RTD_TYPE,
    "Temperature RTD Type",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &HmDmm_rngTemperatureRTDType, NULL, NULL,
    "TEMP:TRAN:RTD:TYPE",
    // Defaults I32, I64, Float, Bool, String
    HMDMM_VAL_TEMP_RTD_PT100,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_TEMPERATURE_PROBE_TYPE =
  {
    HMDMM_ATTR_TEMPERATURE_PROBE_TYPE,
    "Temperature Probe Type",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &HmDmm_rngTemperatureProbeType, NULL, NULL,
    "TEMP:TRAN:TYPE",
    // Defaults I32, I64, Float, Bool, String
    HMDMM_VAL_TEMP_TRANSDUCER_PROBE_RTD,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_CAPACITANCE_RANGE =
  {
    HMDMM_ATTR_CAPACITANCE_RANGE,
    "Capacitance Range",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, &HmDmm_rngCapacitanceRange,
    "CAP:RANG",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    5e-9,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_CAPACITANCE_AUTO_RANGE =
  {
    HMDMM_ATTR_CAPACITANCE_AUTO_RANGE,
    "Capacitance Auto Range",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CAP:RANG:AUTO",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_TRUE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_CAPACITANCE_NULL_FUNCTION_STATE =
  {
    HMDMM_ATTR_CAPACITANCE_NULL_FUNCTION_STATE,
    "Capacitance Null Function State",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CAP:NULL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_CAPACITANCE_NULL =
  {
    HMDMM_ATTR_CAPACITANCE_NULL,
    "Capacitance Null",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "CAP:NULL:VAL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_CONTINUITY_BEEPER =
  {
    HMDMM_ATTR_CONTINUITY_BEEPER,
    "Continuity Beeper",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "SENSE:CONT:BEEP",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_CONTINUITY_THRESHOLD =
  {
    HMDMM_ATTR_CONTINUITY_THRESHOLD,
    "Continuity Threshold",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, &HmDmm_rngContinuityThreshold, NULL,
    "SENS:CONT:THR",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    200.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_DIODE_BEEPER =
  {
    HMDMM_ATTR_DIODE_BEEPER,
    "Diode Beeper",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "SENS:DIOD:BEEP",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_DIODE_THRESHOLD =
  {
    HMDMM_ATTR_DIODE_THRESHOLD,
    "Diode Threshold",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, &HmDmm_rngDiodeThreshold, NULL,
    "SENS:DIOD:THR",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    700.0e-3,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_INITIATE =
  {
    HMDMM_ATTR_INITIATE,
    "Initiate",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "INIT:IMM",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_WAIT_FOR_OPC,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_SEND_SOFTWARE_TRIGGER =
  {
    HMDMM_ATTR_SEND_SOFTWARE_TRIGGER,
    "Send Software Trigger",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "*TRG",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_ADC_RATE =
  {
    HMDMM_ATTR_ADC_RATE,
    "ADC Rate",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &HmDmm_rngADCRate, NULL, NULL,
    "SENS:ADCR",
    // Defaults I32, I64, Float, Bool, String
    HMDMM_VAL_ADC_RATE_SLOW,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_TRIGGER_MODE =
  {
    HMDMM_ATTR_TRIGGER_MODE,
    "Trigger Mode",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &HmDmm_rngTriggerMode, NULL, NULL,
    "TRIG:MODE",
    // Defaults I32, I64, Float, Bool, String
    HMDMM_VAL_TRIGGER_AUTO,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_TRIGGER_AUTO_MODE =
  {
    HMDMM_ATTR_TRIGGER_AUTO_MODE,
    "Trigger Auto Mode",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &HmDmm_rngTriggerAutoMode, NULL, NULL,
    "TRIG:LEV:MOD",
    // Defaults I32, I64, Float, Bool, String
    HMDMM_VAL_TRIGGER_AUTO_CONTINUE,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_TRIGGER_THRESHOLD =
  {
    HMDMM_ATTR_TRIGGER_THRESHOLD,
    "Trigger Threshold",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "TRIG:LEV",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_TRIGGER_INTERVAL =
  {
    HMDMM_ATTR_TRIGGER_INTERVAL,
    "Trigger Interval",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "TRIG:INT",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_TRIGGER_COUNT =
  {
    HMDMM_ATTR_TRIGGER_COUNT,
    "Trigger Count",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, &HmDmm_rngTriggerCount, NULL,
    "TRIG:COUN",
    // Defaults I32, I64, Float, Bool, String
    1,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    hmdmm_DoubleToInt_ReadCallback,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_MATH_ENABLED =
  {
    HMDMM_ATTR_MATH_ENABLED,
    "Math Enabled",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "CALC:STAT",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_MATH_FUNCTION =
  {
    HMDMM_ATTR_MATH_FUNCTION,
    "Math Function",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &HmDmm_rngMathFunction, NULL, NULL,
    "CALC:FUNC",
    // Defaults I32, I64, Float, Bool, String
    HMDMM_VAL_MATH_NULL,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_MATH_OFFSET =
  {
    HMDMM_ATTR_MATH_OFFSET,
    "Math Offset",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "CALC:NULL:OFFS",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_MATH_DB_REFERENCE =
  {
    HMDMM_ATTR_MATH_DB_REFERENCE,
    "Math dB Reference",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, &HmDmm_rngdBReference, NULL,
    "CALC:DB:REF",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    50.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_MATH_DBM_REFERENCE =
  {
    HMDMM_ATTR_MATH_DBM_REFERENCE,
    "Math dBm Reference",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    "CALC:DBM:REF",
    // Defaults I32, I64, Float, Bool, String
    50,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    hmdmm_DoubleToInt_ReadCallback,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_MATH_DC_POWER =
  {
    HMDMM_ATTR_MATH_DC_POWER,
    "Math DC Power",
    RS_VAL_READ_ONLY,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "CALC:POW?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_LOWER_LIMIT =
  {
    HMDMM_ATTR_LOWER_LIMIT,
    "Lower Limit",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "CALC:LIM:LOW",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_UPPER_LIMIT =
  {
    HMDMM_ATTR_UPPER_LIMIT,
    "Upper Limit",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "CALC:LIM:UPP",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_AVERAGE_MINIMUM =
  {
    HMDMM_ATTR_AVERAGE_MINIMUM,
    "Average Minimum",
    RS_VAL_READ_ONLY,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "CALC:AVER:MIN?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_AVERAGE_MAXIMUM =
  {
    HMDMM_ATTR_AVERAGE_MAXIMUM,
    "Average Maximum",
    RS_VAL_READ_ONLY,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "CALC:AVER:MAX?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    1.5,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_AVERAGE_PEAK_TO_PEAK =
  {
    HMDMM_ATTR_AVERAGE_PEAK_TO_PEAK,
    "Average Peak To Peak",
    RS_VAL_READ_ONLY,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "CALC:AVER:PTP?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_AVERAGE_STANDARD_DEVIATION =
  {
    HMDMM_ATTR_AVERAGE_STANDARD_DEVIATION,
    "Average Standard Deviation",
    RS_VAL_READ_ONLY,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "CALC:AVER:SDEV?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_AVERAGE =
  {
    HMDMM_ATTR_AVERAGE,
    "Average",
    RS_VAL_READ_ONLY,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "CALC:AVER:AVER?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.5,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_AVERAGE_COUNT =
  {
    HMDMM_ATTR_AVERAGE_COUNT,
    "Average Count",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    "CALC:AVER:COUN?",
    // Defaults I32, I64, Float, Bool, String
    3,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    hmdmm_DoubleToInt_ReadCallback,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_AVERAGE_CLEAR =
  {
    HMDMM_ATTR_AVERAGE_CLEAR,
    "Average Clear",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "CALC:AVER:CLE",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_HARDCOPY_FORMAT =
  {
    HMDMM_ATTR_HARDCOPY_FORMAT,
    "Hardcopy Format",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &HmDmm_rngHardcopyFormat, NULL, NULL,
    "HCOP:FORM",
    // Defaults I32, I64, Float, Bool, String
    HMDMM_VAL_HARDCOPY_FORMAT_BMP,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_HARDCOPY_SIZE_X =
  {
    HMDMM_ATTR_HARDCOPY_SIZE_X,
    "Hardcopy Size X",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    "HCOP:SIZE:X?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_HARDCOPY_SIZE_Y =
  {
    HMDMM_ATTR_HARDCOPY_SIZE_Y,
    "Hardcopy Size Y",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    "HCOP:SIZE:Y?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_DATA_LOGGING =
  {
    HMDMM_ATTR_DATA_LOGGING,
    "Data Logging",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "DATA:LOG",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_DATA_LOGGING_FILE_FORMAT =
  {
    HMDMM_ATTR_DATA_LOGGING_FILE_FORMAT,
    "Data Logging File Format",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &HmDmm_rngDataLoggingFileFormat, NULL, NULL,
    "DATA:LOG:FORM",
    // Defaults I32, I64, Float, Bool, String
    HMDMM_VAL_DATA_LOG_FORMAT_CSV,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_DATA_LOGGING_MODE =
  {
    HMDMM_ATTR_DATA_LOGGING_MODE,
    "Data Logging Mode",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &HmDmm_rngDataLoggingMode, NULL, NULL,
    "DATA:LOG:MODE",
    // Defaults I32, I64, Float, Bool, String
    HMDMM_VAL_DATA_LOG_MODE_UNLIMITED,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_DATA_LOGGING_TIME =
  {
    HMDMM_ATTR_DATA_LOGGING_TIME,
    "Data Logging Time",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "DATA:LOG:TIME",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    1.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_DATA_LOGGING_MEASUREMENT_INTERVAL =
  {
    HMDMM_ATTR_DATA_LOGGING_MEASUREMENT_INTERVAL,
    "Data Logging Measurement Interval",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, &HmDmm_rngDataLoggingMeasurementInterval, NULL,
    "DATA:LOG:INT",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_DATA_LOGGING_MEASUREMENT_COUNT =
  {
    HMDMM_ATTR_DATA_LOGGING_MEASUREMENT_COUNT,
    "Data Logging Measurement Count",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    "DATA:LOG:COUN",
    // Defaults I32, I64, Float, Bool, String
    1,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    hmdmm_DoubleToInt_ReadCallback,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_ID_QUERY_RESPONSE =
  {
    HMDMM_ATTR_ID_QUERY_RESPONSE,
    "ID Query Response",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    "*IDN?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    "HAMEG,DMM,123456/789,1.23",
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_SYSTEM_ERROR =
  {
    HMDMM_ATTR_SYSTEM_ERROR,
    "System Error",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    "SYST:ERR?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    "0",
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_SYSTEM_NEXT_ERROR =
  {
    HMDMM_ATTR_SYSTEM_NEXT_ERROR,
    "System Next Error",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    "SYST:ERR?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    "0",
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_SYSTEM_VERSION =
  {
    HMDMM_ATTR_SYSTEM_VERSION,
    "System Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    "SYST:VERS?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_SYSTEM_LOCAL =
  {
    HMDMM_ATTR_SYSTEM_LOCAL,
    "System Local",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "SYST:LOC",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_SYSTEM_REMOTE =
  {
    HMDMM_ATTR_SYSTEM_REMOTE,
    "System Remote",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "SYST:REM",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_SYSTEM_RW_LOCK =
  {
    HMDMM_ATTR_SYSTEM_RW_LOCK,
    "System RW Lock",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "SYST:RWL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_PROCESS_ALL_PREVIOUS_COMMANDS =
  {
    HMDMM_ATTR_PROCESS_ALL_PREVIOUS_COMMANDS,
    "Process All Previous Commands",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "*WAI",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_HMDMM_ATTR_LOGGING =
  {
    HMDMM_ATTR_LOGGING,
    "Logging",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "no_command",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    hmdmm_logging_ReadCallback,
    hmdmm_logging_WriteCallback,
    NULL,
  };


/*****************************************************************************
 *- Attributes List ---------------------------------------------------------*
 *****************************************************************************/

ViInt32 hmdmm_RsCoreAttributeListLength = 135;

RsCoreAttributePtr hmdmm_RsCoreAttributeList[135] =
  {
    &g_RS_ATTR_RANGE_CHECK,
    &g_RS_ATTR_QUERY_INSTRUMENT_STATUS,
    &g_RS_ATTR_SIMULATE,
    &g_RS_ATTR_SPECIFIC_DRIVER_DESCRIPTION,
    &g_RS_ATTR_SPECIFIC_DRIVER_PREFIX,
    &g_RS_ATTR_SPECIFIC_DRIVER_LOCATOR,
    &g_RS_ATTR_SPECIFIC_DRIVER_VENDOR,
    &g_RS_ATTR_SPECIFIC_DRIVER_REVISION,
    &g_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MAJOR_VERSION,
    &g_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MINOR_VERSION,
    &g_RS_ATTR_SUPPORTED_INSTRUMENT_MODELS,
    &g_RS_ATTR_GROUP_CAPABILITIES,
    &g_RS_ATTR_FUNCTION_CAPABILITIES,
    &g_RS_ATTR_CHANNEL_COUNT,
    &g_RS_ATTR_DRIVER_SETUP,
    &g_RS_ATTR_INSTRUMENT_MANUFACTURER,
    &g_RS_ATTR_INSTRUMENT_MODEL,
    &g_RS_ATTR_INSTRUMENT_FIRMWARE_REVISION,
    &g_RS_ATTR_OPTIONS_LIST,
    &g_RS_ATTR_IO_RESOURCE_DESCRIPTOR,
    &g_RS_ATTR_LOGICAL_NAME,
    &g_RS_ATTR_PRIMARY_ERROR,
    &g_RS_ATTR_SECONDARY_ERROR,
    &g_RS_ATTR_ERROR_ELABORATION,
    &g_RS_ATTR_SPECIFIC_DRIVER_MAJOR_VERSION,
    &g_RS_ATTR_SPECIFIC_DRIVER_MINOR_VERSION,
    &g_RS_ATTR_SPECIFIC_DRIVER_MINOR_MINOR_VERSION,
    &g_RS_ATTR_CLASS_DRIVER_MAJOR_VERSION,
    &g_RS_ATTR_CLASS_DRIVER_MINOR_VERSION,
    &g_RS_ATTR_ENGINE_MAJOR_VERSION,
    &g_RS_ATTR_ENGINE_MINOR_VERSION,
    &g_RS_ATTR_ENGINE_REVISION,
    &g_RS_ATTR_OPC_TIMEOUT,
    &g_HMDMM_ATTR_FUNCTION,
    &g_HMDMM_ATTR_ACTUAL_INSTRUMENT_CONFIGURATION,
    &g_HMDMM_ATTR_DC_VOLTAGE_RANGE,
    &g_HMDMM_ATTR_DC_VOLTAGE_AUTO_RANGE,
    &g_HMDMM_ATTR_DC_VOLTAGE_AUTOZERO,
    &g_HMDMM_ATTR_DC_VOLTAGE_NULL_FUNCTION_STATE,
    &g_HMDMM_ATTR_DC_VOLTAGE_NULL,
    &g_HMDMM_ATTR_DC_CURRENT_RANGE,
    &g_HMDMM_ATTR_DC_CURRENT_AUTO_RANGE,
    &g_HMDMM_ATTR_DC_CURRENT_NULL_FUNCTION_STATE,
    &g_HMDMM_ATTR_DC_CURRENT_NULL,
    &g_HMDMM_ATTR_AC_VOLTAGE_DETECTOR_BANDWIDTH,
    &g_HMDMM_ATTR_AC_VOLTAGE_RANGE,
    &g_HMDMM_ATTR_AC_VOLTAGE_AUTO_RANGE,
    &g_HMDMM_ATTR_AC_VOLTAGE_NULL_FUNCTION_STATE,
    &g_HMDMM_ATTR_AC_VOLTAGE_NULL,
    &g_HMDMM_ATTR_AC_CURRENT_DETECTOR_BANDWIDTH,
    &g_HMDMM_ATTR_AC_CURRENT_RANGE,
    &g_HMDMM_ATTR_AC_CURRENT_AUTO_RANGE,
    &g_HMDMM_ATTR_AC_CURRENT_NULL_FUNCTION_STATE,
    &g_HMDMM_ATTR_AC_CURRENT_NULL,
    &g_HMDMM_ATTR_SELF_TEST,
    &g_HMDMM_ATTR_SAVE,
    &g_HMDMM_ATTR_RECALL,
    &g_HMDMM_ATTR_DISPLAY_TEXT,
    &g_HMDMM_ATTR_DISPLAY_CLEAR,
    &g_HMDMM_ATTR_BEEPER_STATE,
    &g_HMDMM_ATTR_BEEP,
    &g_HMDMM_ATTR_PRESET_REGISTER,
    &g_HMDMM_ATTR_STATUS_REGISTER_QUESTIONABLE_CONDITION,
    &g_HMDMM_ATTR_STATUS_REGISTER_QUESTIONABLE_ENABLE,
    &g_HMDMM_ATTR_STATUS_REGISTER_QUESTIONABLE_EVENT,
    &g_HMDMM_ATTR_STATUS_REGISTER_OPERATION_CONDITION,
    &g_HMDMM_ATTR_STATUS_REGISTER_OPERATION_ENABLE,
    &g_HMDMM_ATTR_STATUS_REGISTER_OPERATION_EVENT,
    &g_HMDMM_ATTR_FREQ_APERTURE_TIME,
    &g_HMDMM_ATTR_AUTO_FREQ_VOLTAGE_RANGE,
    &g_HMDMM_ATTR_FREQ_VOLTAGE_RANGE,
    &g_HMDMM_ATTR_FREQ_CURRENT_AUTO_RANGE,
    &g_HMDMM_ATTR_FREQ_CURRENT_RANGE,
    &g_HMDMM_ATTR_TWO_WIRES_RESISTANCE_RANGE,
    &g_HMDMM_ATTR_TWO_WIRES_RESISTANCE_AUTO_RANGE,
    &g_HMDMM_ATTR_TWO_WIRES_RESISTANCE_NULL_FUNCTION_STATE,
    &g_HMDMM_ATTR_TWO_WIRES_RESISTANCE_NULL,
    &g_HMDMM_ATTR_FOUR_WIRES_RESISTANCE_RANGE,
    &g_HMDMM_ATTR_FOUR_WIRES_RESISTANCE_AUTO_RANGE,
    &g_HMDMM_ATTR_FOUR_WIRES_RESISTANCE_NULL_FUNCTION_STATE,
    &g_HMDMM_ATTR_FOUR_WIRES_RESISTANCE_NULL,
    &g_HMDMM_ATTR_TEMPERATURE_UNIT,
    &g_HMDMM_ATTR_TEMPERATURE_NULL_FUNCTION_STATE,
    &g_HMDMM_ATTR_TEMPERATURE_NULL,
    &g_HMDMM_ATTR_TEMPERATURE_RTD_TYPE,
    &g_HMDMM_ATTR_TEMPERATURE_PROBE_TYPE,
    &g_HMDMM_ATTR_CAPACITANCE_RANGE,
    &g_HMDMM_ATTR_CAPACITANCE_AUTO_RANGE,
    &g_HMDMM_ATTR_CAPACITANCE_NULL_FUNCTION_STATE,
    &g_HMDMM_ATTR_CAPACITANCE_NULL,
    &g_HMDMM_ATTR_CONTINUITY_BEEPER,
    &g_HMDMM_ATTR_CONTINUITY_THRESHOLD,
    &g_HMDMM_ATTR_DIODE_BEEPER,
    &g_HMDMM_ATTR_DIODE_THRESHOLD,
    &g_HMDMM_ATTR_INITIATE,
    &g_HMDMM_ATTR_SEND_SOFTWARE_TRIGGER,
    &g_HMDMM_ATTR_ADC_RATE,
    &g_HMDMM_ATTR_TRIGGER_MODE,
    &g_HMDMM_ATTR_TRIGGER_AUTO_MODE,
    &g_HMDMM_ATTR_TRIGGER_THRESHOLD,
    &g_HMDMM_ATTR_TRIGGER_INTERVAL,
    &g_HMDMM_ATTR_TRIGGER_COUNT,
    &g_HMDMM_ATTR_MATH_ENABLED,
    &g_HMDMM_ATTR_MATH_FUNCTION,
    &g_HMDMM_ATTR_MATH_OFFSET,
    &g_HMDMM_ATTR_MATH_DB_REFERENCE,
    &g_HMDMM_ATTR_MATH_DBM_REFERENCE,
    &g_HMDMM_ATTR_MATH_DC_POWER,
    &g_HMDMM_ATTR_LOWER_LIMIT,
    &g_HMDMM_ATTR_UPPER_LIMIT,
    &g_HMDMM_ATTR_AVERAGE_MINIMUM,
    &g_HMDMM_ATTR_AVERAGE_MAXIMUM,
    &g_HMDMM_ATTR_AVERAGE_PEAK_TO_PEAK,
    &g_HMDMM_ATTR_AVERAGE_STANDARD_DEVIATION,
    &g_HMDMM_ATTR_AVERAGE,
    &g_HMDMM_ATTR_AVERAGE_COUNT,
    &g_HMDMM_ATTR_AVERAGE_CLEAR,
    &g_HMDMM_ATTR_HARDCOPY_FORMAT,
    &g_HMDMM_ATTR_HARDCOPY_SIZE_X,
    &g_HMDMM_ATTR_HARDCOPY_SIZE_Y,
    &g_HMDMM_ATTR_DATA_LOGGING,
    &g_HMDMM_ATTR_DATA_LOGGING_FILE_FORMAT,
    &g_HMDMM_ATTR_DATA_LOGGING_MODE,
    &g_HMDMM_ATTR_DATA_LOGGING_TIME,
    &g_HMDMM_ATTR_DATA_LOGGING_MEASUREMENT_INTERVAL,
    &g_HMDMM_ATTR_DATA_LOGGING_MEASUREMENT_COUNT,
    &g_HMDMM_ATTR_ID_QUERY_RESPONSE,
    &g_HMDMM_ATTR_SYSTEM_ERROR,
    &g_HMDMM_ATTR_SYSTEM_NEXT_ERROR,
    &g_HMDMM_ATTR_SYSTEM_VERSION,
    &g_HMDMM_ATTR_SYSTEM_LOCAL,
    &g_HMDMM_ATTR_SYSTEM_REMOTE,
    &g_HMDMM_ATTR_SYSTEM_RW_LOCK,
    &g_HMDMM_ATTR_PROCESS_ALL_PREVIOUS_COMMANDS,
    &g_HMDMM_ATTR_LOGGING
  };
