/*****************************************************************************
 *  Rohde&Schwarz Instrument Driver Specific Attribute callbacks include file
 *
 *  WARNING: Do not add to, delete from, or otherwise modify the contents
 *           of this include file. It is generated from DrBase repository.
 *
 *  Built on: 2024-04-03 11:14:32Z
 *****************************************************************************/

#ifndef __HMDMM_ATTRIBUTES_HEADER
#define __HMDMM_ATTRIBUTES_HEADER

#include "rscore.h"

#if defined(__cplusplus) || defined(__cplusplus__)
extern "C" {
#endif

/*****************************************************************************
 *- Read Callbacks ----------------------------------------------------------*
 *****************************************************************************/
ViStatus hmdmm_doubleQuotedInt_ReadCallback(ViSession io, ViConstString repCapName, RsCoreAttributePtr attr);
ViStatus hmdmm_DoubleToInt_ReadCallback(ViSession io, ViConstString repCapName, RsCoreAttributePtr attr);
ViStatus hmdmm_logging_ReadCallback(ViSession io, ViConstString repCapName, RsCoreAttributePtr attr);

/*****************************************************************************
 *- Write Callbacks ---------------------------------------------------------*
 *****************************************************************************/
ViStatus hmdmm_doubleQuotedInt_WriteCallback(ViSession io, ViConstString repCapName, RsCoreAttributePtr attr, void *value);
ViStatus hmdmm_logging_WriteCallback(ViSession io, ViConstString repCapName, RsCoreAttributePtr attr, void *value);

/*****************************************************************************
 *- Range Tables ------------------------------------------------------------*
 *****************************************************************************/
extern RsCoreRangeTableDiscrete HmDmm_rngFunction;
extern RsCoreRangeTableDiscrete HmDmm_rngBandwidth;
extern RsCoreRangeTableDiscrete HmDmm_rngAuto;
extern RsCoreRangeTableCoerced HmDmm_rngApertureTime;
extern RsCoreRangeTableRanged HmDmm_rngTriggerCount;
extern RsCoreRangeTableRanged HmDmm_rngSave;
extern RsCoreRangeTableDiscrete HmDmm_rngMathFunction;
extern RsCoreRangeTableRanged HmDmm_rngdBReference;
extern RsCoreRangeTableCoerced HmDmm_rngdBmReference;
extern RsCoreRangeTableDiscrete HmDmm_rngTransducerType;
extern RsCoreRangeTableDiscrete HmDmm_rngTemperatureSensorType;
extern RsCoreRangeTableRanged HmDmm_rngRegister;
extern RsCoreRangeTableCoerced HmDmm_rngDCVoltageRange;
extern RsCoreRangeTableCoerced HmDmm_rngDCCurrentRange;
extern RsCoreRangeTableCoerced HmDmm_rngACVoltageRange;
extern RsCoreRangeTableCoerced HmDmm_rngACCurrentRange;
extern RsCoreRangeTableCoerced HmDmm_rngTwoWiresResistanceRange;
extern RsCoreRangeTableDiscrete HmDmm_rngAutoImpedance;
extern RsCoreRangeTableDiscrete HmDmm_rngOnOff;
extern RsCoreRangeTableDiscrete HmDmm_rngTemperatureUnit;
extern RsCoreRangeTableDiscrete HmDmm_rngTemperatureRTDType;
extern RsCoreRangeTableDiscrete HmDmm_rngTemperatureProbeType;
extern RsCoreRangeTableDiscrete HmDmm_rngTriggerMode;
extern RsCoreRangeTableDiscrete HmDmm_rngTriggerAutoMode;
extern RsCoreRangeTableDiscrete HmDmm_rngHardcopyFormat;
extern RsCoreRangeTableCoerced HmDmm_rngCapacitanceRange;
extern RsCoreRangeTableCoerced HmDmm_rngFourWiresResistanceRange;
extern RsCoreRangeTableDiscrete HmDmm_rngADCRate;
extern RsCoreRangeTableRanged HmDmm_rngContinuityThreshold;
extern RsCoreRangeTableRanged HmDmm_rngDiodeThreshold;
extern RsCoreRangeTableDiscrete HmDmm_rngDataLoggingFileFormat;
extern RsCoreRangeTableDiscrete HmDmm_rngDataLoggingMode;
extern RsCoreRangeTableRanged HmDmm_rngDataLoggingMeasurementInterval;
extern RsCoreRangeTableDiscrete HmDmm_rngIntExt;

/*****************************************************************************
 *- Attributes --------------------------------------------------------------*
 *****************************************************************************/
extern RsCoreAttribute g_RS_ATTR_RANGE_CHECK;
extern RsCoreAttribute g_RS_ATTR_QUERY_INSTRUMENT_STATUS;
extern RsCoreAttribute g_RS_ATTR_SIMULATE;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_DESCRIPTION;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_PREFIX;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_LOCATOR;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_VENDOR;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_REVISION;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MAJOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MINOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_SUPPORTED_INSTRUMENT_MODELS;
extern RsCoreAttribute g_RS_ATTR_GROUP_CAPABILITIES;
extern RsCoreAttribute g_RS_ATTR_FUNCTION_CAPABILITIES;
extern RsCoreAttribute g_RS_ATTR_CHANNEL_COUNT;
extern RsCoreAttribute g_RS_ATTR_DRIVER_SETUP;
extern RsCoreAttribute g_RS_ATTR_INSTRUMENT_MANUFACTURER;
extern RsCoreAttribute g_RS_ATTR_INSTRUMENT_MODEL;
extern RsCoreAttribute g_RS_ATTR_INSTRUMENT_FIRMWARE_REVISION;
extern RsCoreAttribute g_RS_ATTR_OPTIONS_LIST;
extern RsCoreAttribute g_RS_ATTR_IO_RESOURCE_DESCRIPTOR;
extern RsCoreAttribute g_RS_ATTR_LOGICAL_NAME;
extern RsCoreAttribute g_RS_ATTR_PRIMARY_ERROR;
extern RsCoreAttribute g_RS_ATTR_SECONDARY_ERROR;
extern RsCoreAttribute g_RS_ATTR_ERROR_ELABORATION;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_MAJOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_MINOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_MINOR_MINOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_CLASS_DRIVER_MAJOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_CLASS_DRIVER_MINOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_ENGINE_MAJOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_ENGINE_MINOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_ENGINE_REVISION;
extern RsCoreAttribute g_RS_ATTR_OPC_TIMEOUT;
extern RsCoreAttribute g_HMDMM_ATTR_FUNCTION;
extern RsCoreAttribute g_HMDMM_ATTR_ACTUAL_INSTRUMENT_CONFIGURATION;
extern RsCoreAttribute g_HMDMM_ATTR_DC_VOLTAGE_RANGE;
extern RsCoreAttribute g_HMDMM_ATTR_DC_VOLTAGE_AUTO_RANGE;
extern RsCoreAttribute g_HMDMM_ATTR_DC_VOLTAGE_AUTOZERO;
extern RsCoreAttribute g_HMDMM_ATTR_DC_VOLTAGE_NULL_FUNCTION_STATE;
extern RsCoreAttribute g_HMDMM_ATTR_DC_VOLTAGE_NULL;
extern RsCoreAttribute g_HMDMM_ATTR_DC_CURRENT_RANGE;
extern RsCoreAttribute g_HMDMM_ATTR_DC_CURRENT_AUTO_RANGE;
extern RsCoreAttribute g_HMDMM_ATTR_DC_CURRENT_NULL_FUNCTION_STATE;
extern RsCoreAttribute g_HMDMM_ATTR_DC_CURRENT_NULL;
extern RsCoreAttribute g_HMDMM_ATTR_AC_VOLTAGE_DETECTOR_BANDWIDTH;
extern RsCoreAttribute g_HMDMM_ATTR_AC_VOLTAGE_RANGE;
extern RsCoreAttribute g_HMDMM_ATTR_AC_VOLTAGE_AUTO_RANGE;
extern RsCoreAttribute g_HMDMM_ATTR_AC_VOLTAGE_NULL_FUNCTION_STATE;
extern RsCoreAttribute g_HMDMM_ATTR_AC_VOLTAGE_NULL;
extern RsCoreAttribute g_HMDMM_ATTR_AC_CURRENT_DETECTOR_BANDWIDTH;
extern RsCoreAttribute g_HMDMM_ATTR_AC_CURRENT_RANGE;
extern RsCoreAttribute g_HMDMM_ATTR_AC_CURRENT_AUTO_RANGE;
extern RsCoreAttribute g_HMDMM_ATTR_AC_CURRENT_NULL_FUNCTION_STATE;
extern RsCoreAttribute g_HMDMM_ATTR_AC_CURRENT_NULL;
extern RsCoreAttribute g_HMDMM_ATTR_SELF_TEST;
extern RsCoreAttribute g_HMDMM_ATTR_SAVE;
extern RsCoreAttribute g_HMDMM_ATTR_RECALL;
extern RsCoreAttribute g_HMDMM_ATTR_DISPLAY_TEXT;
extern RsCoreAttribute g_HMDMM_ATTR_DISPLAY_CLEAR;
extern RsCoreAttribute g_HMDMM_ATTR_BEEPER_STATE;
extern RsCoreAttribute g_HMDMM_ATTR_BEEP;
extern RsCoreAttribute g_HMDMM_ATTR_PRESET_REGISTER;
extern RsCoreAttribute g_HMDMM_ATTR_STATUS_REGISTER_QUESTIONABLE_CONDITION;
extern RsCoreAttribute g_HMDMM_ATTR_STATUS_REGISTER_QUESTIONABLE_ENABLE;
extern RsCoreAttribute g_HMDMM_ATTR_STATUS_REGISTER_QUESTIONABLE_EVENT;
extern RsCoreAttribute g_HMDMM_ATTR_STATUS_REGISTER_OPERATION_CONDITION;
extern RsCoreAttribute g_HMDMM_ATTR_STATUS_REGISTER_OPERATION_ENABLE;
extern RsCoreAttribute g_HMDMM_ATTR_STATUS_REGISTER_OPERATION_EVENT;
extern RsCoreAttribute g_HMDMM_ATTR_FREQ_APERTURE_TIME;
extern RsCoreAttribute g_HMDMM_ATTR_AUTO_FREQ_VOLTAGE_RANGE;
extern RsCoreAttribute g_HMDMM_ATTR_FREQ_VOLTAGE_RANGE;
extern RsCoreAttribute g_HMDMM_ATTR_FREQ_CURRENT_AUTO_RANGE;
extern RsCoreAttribute g_HMDMM_ATTR_FREQ_CURRENT_RANGE;
extern RsCoreAttribute g_HMDMM_ATTR_TWO_WIRES_RESISTANCE_RANGE;
extern RsCoreAttribute g_HMDMM_ATTR_TWO_WIRES_RESISTANCE_AUTO_RANGE;
extern RsCoreAttribute g_HMDMM_ATTR_TWO_WIRES_RESISTANCE_NULL_FUNCTION_STATE;
extern RsCoreAttribute g_HMDMM_ATTR_TWO_WIRES_RESISTANCE_NULL;
extern RsCoreAttribute g_HMDMM_ATTR_FOUR_WIRES_RESISTANCE_RANGE;
extern RsCoreAttribute g_HMDMM_ATTR_FOUR_WIRES_RESISTANCE_AUTO_RANGE;
extern RsCoreAttribute g_HMDMM_ATTR_FOUR_WIRES_RESISTANCE_NULL_FUNCTION_STATE;
extern RsCoreAttribute g_HMDMM_ATTR_FOUR_WIRES_RESISTANCE_NULL;
extern RsCoreAttribute g_HMDMM_ATTR_TEMPERATURE_UNIT;
extern RsCoreAttribute g_HMDMM_ATTR_TEMPERATURE_NULL_FUNCTION_STATE;
extern RsCoreAttribute g_HMDMM_ATTR_TEMPERATURE_NULL;
extern RsCoreAttribute g_HMDMM_ATTR_TEMPERATURE_RTD_TYPE;
extern RsCoreAttribute g_HMDMM_ATTR_TEMPERATURE_PROBE_TYPE;
extern RsCoreAttribute g_HMDMM_ATTR_CAPACITANCE_RANGE;
extern RsCoreAttribute g_HMDMM_ATTR_CAPACITANCE_AUTO_RANGE;
extern RsCoreAttribute g_HMDMM_ATTR_CAPACITANCE_NULL_FUNCTION_STATE;
extern RsCoreAttribute g_HMDMM_ATTR_CAPACITANCE_NULL;
extern RsCoreAttribute g_HMDMM_ATTR_CONTINUITY_BEEPER;
extern RsCoreAttribute g_HMDMM_ATTR_CONTINUITY_THRESHOLD;
extern RsCoreAttribute g_HMDMM_ATTR_DIODE_BEEPER;
extern RsCoreAttribute g_HMDMM_ATTR_DIODE_THRESHOLD;
extern RsCoreAttribute g_HMDMM_ATTR_INITIATE;
extern RsCoreAttribute g_HMDMM_ATTR_SEND_SOFTWARE_TRIGGER;
extern RsCoreAttribute g_HMDMM_ATTR_ADC_RATE;
extern RsCoreAttribute g_HMDMM_ATTR_TRIGGER_MODE;
extern RsCoreAttribute g_HMDMM_ATTR_TRIGGER_AUTO_MODE;
extern RsCoreAttribute g_HMDMM_ATTR_TRIGGER_THRESHOLD;
extern RsCoreAttribute g_HMDMM_ATTR_TRIGGER_INTERVAL;
extern RsCoreAttribute g_HMDMM_ATTR_TRIGGER_COUNT;
extern RsCoreAttribute g_HMDMM_ATTR_MATH_ENABLED;
extern RsCoreAttribute g_HMDMM_ATTR_MATH_FUNCTION;
extern RsCoreAttribute g_HMDMM_ATTR_MATH_OFFSET;
extern RsCoreAttribute g_HMDMM_ATTR_MATH_DB_REFERENCE;
extern RsCoreAttribute g_HMDMM_ATTR_MATH_DBM_REFERENCE;
extern RsCoreAttribute g_HMDMM_ATTR_MATH_DC_POWER;
extern RsCoreAttribute g_HMDMM_ATTR_LOWER_LIMIT;
extern RsCoreAttribute g_HMDMM_ATTR_UPPER_LIMIT;
extern RsCoreAttribute g_HMDMM_ATTR_AVERAGE_MINIMUM;
extern RsCoreAttribute g_HMDMM_ATTR_AVERAGE_MAXIMUM;
extern RsCoreAttribute g_HMDMM_ATTR_AVERAGE_PEAK_TO_PEAK;
extern RsCoreAttribute g_HMDMM_ATTR_AVERAGE_STANDARD_DEVIATION;
extern RsCoreAttribute g_HMDMM_ATTR_AVERAGE;
extern RsCoreAttribute g_HMDMM_ATTR_AVERAGE_COUNT;
extern RsCoreAttribute g_HMDMM_ATTR_AVERAGE_CLEAR;
extern RsCoreAttribute g_HMDMM_ATTR_HARDCOPY_FORMAT;
extern RsCoreAttribute g_HMDMM_ATTR_HARDCOPY_SIZE_X;
extern RsCoreAttribute g_HMDMM_ATTR_HARDCOPY_SIZE_Y;
extern RsCoreAttribute g_HMDMM_ATTR_DATA_LOGGING;
extern RsCoreAttribute g_HMDMM_ATTR_DATA_LOGGING_FILE_FORMAT;
extern RsCoreAttribute g_HMDMM_ATTR_DATA_LOGGING_MODE;
extern RsCoreAttribute g_HMDMM_ATTR_DATA_LOGGING_TIME;
extern RsCoreAttribute g_HMDMM_ATTR_DATA_LOGGING_MEASUREMENT_INTERVAL;
extern RsCoreAttribute g_HMDMM_ATTR_DATA_LOGGING_MEASUREMENT_COUNT;
extern RsCoreAttribute g_HMDMM_ATTR_ID_QUERY_RESPONSE;
extern RsCoreAttribute g_HMDMM_ATTR_SYSTEM_ERROR;
extern RsCoreAttribute g_HMDMM_ATTR_SYSTEM_NEXT_ERROR;
extern RsCoreAttribute g_HMDMM_ATTR_SYSTEM_VERSION;
extern RsCoreAttribute g_HMDMM_ATTR_SYSTEM_LOCAL;
extern RsCoreAttribute g_HMDMM_ATTR_SYSTEM_REMOTE;
extern RsCoreAttribute g_HMDMM_ATTR_SYSTEM_RW_LOCK;
extern RsCoreAttribute g_HMDMM_ATTR_PROCESS_ALL_PREVIOUS_COMMANDS;
extern RsCoreAttribute g_HMDMM_ATTR_LOGGING;

/*****************************************************************************
 *- Repeated Capabilities Table ---------------------------------------------*
 *****************************************************************************/
extern RsCoreRepCap hmdmm_RsCoreRepCapTable[];
extern ViInt32 hmdmm_RsCoreRepCapTableCount;

/*****************************************************************************
 *- Attributes List ---------------------------------------------------------*
 *****************************************************************************/
extern RsCoreAttributePtr hmdmm_RsCoreAttributeList[];
extern ViInt32 hmdmm_RsCoreAttributeListLength;

/****************************************************************************
 *---------------------------- End Include File ----------------------------*
 ****************************************************************************/
#if defined(__cplusplus) || defined(__cplusplus__)
}
#endif
#endif /* __HMDMM_ATTRIBUTES_HEADER */
